/*****************************************************
 NmX^bg ROM\tgEFA
 
 2016.03.02 kake  I/O܂ŏCς
 2016.03.03 oga   Yellow softGDLɈڐA
 
******************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "3048.h"
#include "psx.h"

// rbg[gݒ 16MHz/3048Fp
#define BR2400    207
#define BR4800    103
#define BR9600    51
#define BR19200   25
#define BR38400   12
#define BR57600   8
#define BR115200  3

void initSCI1(int);

/*****************************************************
 wait
                                  2009.1.20 AES Yamada 

******************************************************/
void wait(long loop)
{
  while(loop--);
}

/*****************************************************
 iabs
                                  2016.3.3 oga

******************************************************/
unsigned int iabs(long val)
{
  if(val >= 0)
  {
    return (unsigned int)val;
  }
  else
  {
    return (unsigned int)(val*(-1));
  }
}

/*****************************************************
 PSX-X Rg[ԓǂݎ
                                  2009.1.20 AES Yamada 

******************************************************/
int read_switch(void)
{
  //int ret_val;
  
  // read program select switch
  p_select_sw = (char)(PADR & 0x03);  // P1̏ꍇA00000001&00000011 P2̏ꍇA00000000 & 00000011 man̏ꍇA00000010 & 00000011
  //p_select_sw = 0x01;//kakeꂽƂɂB
  // read start switch
  start_sw    = (char)(PADR & 0x04)>>2;
  //start_sw =1;//kakeꂽƂɂ
  // read max speed switch
  max_speed_sw = (char)(PADR & 0x18)>>3;
  
  return 0;
}

int check_sw(void)
{
  static char old_start_sw = 0;
  static char old_select_sw = 0;

  int ret_val = 0;

  if(p_select_sw != old_select_sw)
  {
    ret_val = 1;
    old_select_sw = p_select_sw;
  }
  if(start_sw != old_start_sw)
  {
    ret_val = 1;
    old_start_sw = start_sw;
  }

  return ret_val;
}


/*****************************************************
 PSX-X Rg[ ϒRǂݎ
                                  2009.1.20 AES Yamada
                                  2016.3.3  oga warningC
                                  
  ǂݍAD̒lʕϐx_speed_pot,y_speed_potɊi[B
	F
	߂lF|eV̒l2bitȏωĂ1,
	ωȂ΂O
******************************************************/
int read_ad(void)
{
  static unsigned int old_x = 0 , old_y = 0;
  unsigned int dh,dl;
  int ret_val ;
  
  // read x,y variable resister
  while((ADCSR & 0x80) == 0){};
  dh = ADDRAH << 2 ;
  dl = ADDRAL >> 6 ;
  x_speed_pot = dh + dl;      //O[oɊi[
  
  dh = ADDRBH << 2 ;
  dl = ADDRBL >> 6 ;
  y_speed_pot = dh + dl;      //O[oɊi[
  ADCSR = ADCSR & ~0x80;
  ret_val = 0;
  
  //// debug code
  
  if(abs(x_speed_pot - old_x) >= 2 ) 
  { // ωʂ̊mF rbgڂł̂ӂh~
    ret_val = 1;
    old_x = x_speed_pot;
  }
  
  if(abs(y_speed_pot - old_y) >= 2 ) 
  { // ωʂ̊mF rbgڂł̂ӂh~
    ret_val = 1;
    old_y = y_speed_pot;
  }

  return ret_val;   // ω1Ԃ
}



/*****************************************************
 PSX-X CPU |[gyADϊX^[g
                                  2009.1.20 AES Yamada 

******************************************************/
void init_cpu(void)
{
  int BR;
  
  // P3 0,1,2 |[go͐ݒ
  P3DDR = P3DDR | 0x03;     // 00000111 
  
  // PA 0,1,2,3,4,5 ͐ݒ
  PADDR = PADDR & ~0x3F;    // 00111111
  
  // AD0,1ݒ
  ADCSR = ADCSR & ~0x80;    // ADCSR ADF NA
  ADCSR = ADCSR |  0x10;    // ADCSR SCAN [hZbg
  ADCSR = ADCSR & ~0x08;    // ADCSR CKS NbN266Xe[gI
  ADCSR = ADCSR |  0x01;    //
  ADCSR = ADCSR & ~0x06;    // ADCSR CH AN0,AN1 ɃZbg
  ADCSR = ADCSR |  0x20;    // ADϊX^[g
  
  // VA|[gݒ
  BR = BR9600;
  initSCI1(BR);
}

/*****************************************************
 VA|[g
                                  2016.03.03 oga Release
  : int {[[gw
 ߒl : 
******************************************************/
void initSCI1(int BR)
{
  int j;
  
  SCI1.SCR.BYTE = SCI1.SMR.BYTE = 0;
  SCI1.BRR = BR;
  
  for(j = 0;j < 3000; j++);
  SCI1.SCR.BYTE = 0x30;
  SCI1.SSR.BYTE;
  SCI1.SSR.BYTE = 0x80;
}

/*****************************************************
 1M
                                  2016.03.03 oga Release
  : char
 ߒl : 
******************************************************/
void SCI1_OUT_d(char c)
{
  while(SCI1.SSR.BIT.TDRE == 0);
  
  SCI1.TDR = c;
  SCI1.SSR.BIT.TDRE = 0;
}

/*****************************************************
 񑗐M
                                  2016.03.03 oga Release
  : char* 
 ߒl : 
******************************************************/
void SCI1_OUT_s(char *st)
{
  while(*st) SCI1_OUT_d(*st++);
}


/*****************************************************
 ϐM
                                  2016.03.03 oga Release
  : uint 5܂
 ߒl : 
******************************************************/
void SCI1_OUT_i(unsigned int val)
{
  char str[5];
  
  str[0] = (char)( ( ( val / 10000 ) % 10 ) + 48 );
  str[1] = (char)( ( ( val / 1000  ) % 10 ) + 48 );
  str[2] = (char)( ( ( val / 100   ) % 10 ) + 48 );
  str[3] = (char)( ( ( val / 10    ) % 10 ) + 48 );
  str[4] = (char)( ( ( val / 1     ) % 10 ) + 48 );
  
  SCI1_OUT_s(str);
}

/*****************************************************
 PSX-X Rg[vO
 						vOI
 						|[góA}jA߂lP
                                  2009.1.20 AES Yamada 
                                  2016.3.2 AES kake P1:case1 P2:case0 man:case2
                                  2016.3.3 oga  oOC
******************************************************/
int set_program_no(void)
{
  int ret_val = 0;
  
  switch(p_select_sw)
  {
    case 0: // center select P2
      //P3DR = P3DR | 0x01;		  //00000000 | 00000001  00000001
      //P3DR = P3DR & ~0x02;    //00000001 & 11111101  00000001
      P3DR = 0x01;				
      ret_val = 0;
      break;
      
    case 1: // left select P1
      //P3DR = P3DR | 0x02;		//00000010 | 00000010  00000010
      //P3DR = P3DR & ~0x01;	//00000010 & 11111110  00000010
      P3DR = 0x00;
      ret_val = 1;
      break;
      
    case 2: // right select Manual
      //P3DR = P3DR & ~0x03;	//00000001 | 11111011  00000001
      P3DR = 0x02;
      ret_val = 0;
      break;
  }
  
  return ret_val;
}

/*****************************************************
 PSX-X Rg[vO
 						X^[gMݒ
                                  2009.1.20 AES Yamada
                                  2016.3.3  oga int^void^ɕύX
******************************************************/
void start_psx(void)
{
  set_program_no();
  P3DR = P3DR | 0x04;
}

/*****************************************************
 PSX-X Rg[vO
 						XgbvMݒ
                                  2009.1.20 AES Yamada
                                  2016.3.3  oga int^void^ɕύX
******************************************************/
void stop_psx(void)
{
  P3DR = P3DR & ~0x04;
}


/*****************************************************
 PSX-X Rg[vO
 						xݒ
                                  2009.1.20 AES Yamada
                                  2016.3.3  oga int^void^ɕύX
 EMP402 ݒKv
  A[Aړ_ɕύXiACTL)
  ]iH)
  p^[iRAMP)
  [giT)
  NxiVS)
******************************************************/
void set_speed(void)
{
  unsigned int speed;
  
  if(x_speed_pot > 812) speed = 10;
  if(x_speed_pot < 212) speed = 42600;
  if(x_speed_pot <= 812 && x_speed_pot >= 212)
  {
    speed = iabs(812 - x_speed_pot) * 71;
    if(speed == 0) speed = 10;
  }
  
  SCI1_OUT_s("V1,");
  SCI1_OUT_i(speed);
  SCI1_OUT_s("\r\n");
  wait(30000);
  
  if(y_speed_pot > 812) speed = 10;
  if(y_speed_pot < 212) speed = 42600;
  if(y_speed_pot <= 812 && y_speed_pot >= 212)
  {
    speed = iabs(812 - y_speed_pot) * 71;
    if(speed == 0) speed = 10;
  }
  
  SCI1_OUT_s("V2,");
  SCI1_OUT_i(speed);
  SCI1_OUT_s("\r\n");
  wait(30000);
  
  //// debug code 16.03.03
  SCI1_OUT_s("V4,");
  SCI1_OUT_i(y_speed_pot);
  SCI1_OUT_s("\r\n");
  wait(30000);
  
}


void scan(void)
{
  SCI1_OUT_s("SCAN1\r\n");
  wait(40000);
  
  SCI1_OUT_s("SCAN2\r\n");
  wait(40000);
}


/*****************************************************
 PSX-X Rg[vO
                                  2009.1.20 AES Yamada 
+++++  incomplete  +++++++++++

******************************************************/
void main(void)
{
  //unsigned int co= 0;
  int run_flag = 0;

  // initialize cpu.
  init_cpu();
  
  //// debug code 16.03.03  oga
  //SCI1_OUT_s("Hello world!\n");
  //int i_debug = 1234;
  //SCI1_OUT_i(i_debug);
  //printf("Helloworld!\r\n");  // printf͓삵Ȃ
  
  read_switch();
  wait(200000);
  
  SCI1_OUT_s("RUN,99\r\n");
  wait(50000);
  SCI1_OUT_s("V1,10\r\n");
  wait(50000);
  SCI1_OUT_s("V2,10\r\n");
  wait(30000);
  
  // main loop. 
  while(1)
  {
    SCI1_OUT_s("S1\r\n");
    wait(30000);
    SCI1_OUT_s("S2\r\n");
    wait(30000);
    
    read_ad();
    //read_switch();
    
    if(start_sw && run_flag == 0)
    {
      start_psx();
      run_flag = 1;
      
      switch(p_select_sw)
      {
        case 0: // center select P2
          SCI1_OUT_s("RUN,1\r\n");
          wait(30000);
          scan();
          break;
        
        case 2: // right select Manual
          SCI1_OUT_s("RUN,2\r\n");
          wait(30000);
          set_speed();
          wait(30000);
          scan();
        break;

        case 1: // left select P1 case1case2ĂB
          SCI1_OUT_s("RUN,0\r\n");
          wait(30000);
          scan();
         break;
      }
    }
    else
    {
      stop_psx();
      if(start_sw == 0) run_flag = 0;
      SCI1_OUT_s("S1\r\n");
      wait(30000);
      SCI1_OUT_s("S2\r\n");
      wait(30000);
    }
    while(1){
      read_switch();
      if(check_sw())
      {
        break;
      }
      if(read_ad() == 1 && p_select_sw ==2)
      {                     // abs(ad - old_ad ) >= 2
        set_speed();        // ]x̑M
      }
    }
  }
}
